module Rubbis
	class Transaction
		def initialize
			@active = false
			@buffer = []
			@dirty = false
		end

		def start!
			@active = true
		end

		def active?
			@active
		end

		def dirty!
			@dirty = true
		end

		def dirty?
			@dirty
		end

		def queue(cmd)
			raise unless @active
			@buffer << cmd
		end

		def buffer
			@buffer
		end
	end
end