class ZSet
	# i've skipped refactoring this code to work in O(logn)
	def initialize
		@entries = []
	end

	def add(score, member)
		entries << [score, member]
		entries.sort!
	end

	def range(start, stop)
		entries[start..stop].map {|x| x[1]}
	end

	def rank(member)
		entries.index {|x| x[1] == member}
	end

	def score(member)
		entries.detect {|x| x[1] == member}[0]
	end

	private

	attr_reader :entries
end